package com.seleniumToolkit.selenium.pageObject

import com.seleniumToolkit.selenium.framework.driver.WebDriverManager
import com.seleniumToolkit.selenium.pageObject.template.AbstractSeleniumToolkitPageObject
import org.openqa.selenium.By
import org.openqa.selenium.WebElement
import org.openqa.selenium.support.FindBy

//PO generated by SeleniumToolkit-Extension
class GetStarted : AbstractSeleniumToolkitPageObject() {
    val URL = "/get-started/"

    //Field declarations
    @FindBy(xpath = "//*[@name='name']")
    var name: WebElement? = null

    @FindBy(xpath = "//*[@name='email']")
    var email: WebElement? = null

    @FindBy(xpath = "//*[@name='phone_number']")
    var phoneNumber: WebElement? = null

    @FindBy(xpath = "//*[@name='company']")
    var company: WebElement? = null

    @FindBy(xpath = "//*[@name='programmLangue_testFramework']")
    var programmLangueTestFramework: WebElement? = null

    @FindBy(xpath = "//*[@name='message']")
    var message: WebElement? = null

    @FindBy(xpath = "//*[@type='submit']")
    var submitButton: WebElement? = null

    var errorFieldsXPath: String? ="//*[contains(@class, 'error') and .//input]"

    //HelperMethods
    fun enterName(input: CharSequence?) {
        enterRepalace(name!!, input)
    }

    val valueOfName: String?
        get() = getValueOfInput(name!!)

    fun enterEmail(input: CharSequence?) {
        enterRepalace(email!!, input)
    }

    val valueOfEmail: String?
        get() = getValueOfInput(email!!)

    fun enterPhoneNumber(input: CharSequence?) {
        enterRepalace(phoneNumber!!, input)
    }

    val valueOfPhoneNumber: String?
        get() = getValueOfInput(phoneNumber!!)

    fun enterCompany(input: CharSequence?) {
        enterRepalace(company!!, input)
    }

    val valueOfCompany: String?
        get() = getValueOfInput(company!!)

    fun enterProgrammLangueTestFramework(input: CharSequence?) {
        enterRepalace(programmLangueTestFramework!!, input)
    }

    val valueOfProgrammLangueTestFramework: String?
        get() = getValueOfInput(programmLangueTestFramework!!)

    fun enterMessage(input: CharSequence?) {
        enterRepalace(message!!, input)
    }

    val valueOfMessage: String?
        get() = getValueOfInput(message!!)

    fun clickSubmitButton() {
        click(submitButton!!)
    }

    fun getErrorFieldSize(): Int {
        return WebDriverManager.getWebdriver().findElements(By.xpath(errorFieldsXPath!!)).size;
    }
}